<template>
    <div
        v-if="shop"
        class="page-container"
    >
        <div class="video-button-container">
            <div
                v-if="balance && isWix && showEmailPlan_B"
                class="info-block__container"
            >
                <div
                    class="info-block"
                >
                    <div class="d-flex align-items-center">
                        <div class="info-block__text">
                            Email sent:
                        </div>
                        <div class="info-block__count">
                            {{ balance.emailSent }}/{{ balance.emailCount }}
                        </div>
                    </div>
                    <b-button
                        class="btn info-block__btn"
                        variant="primary"
                        @click="showModalAddEmailCredits = true"
                    >
                        Add email credits
                    </b-button> 
                </div>
            </div>
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-email-browse-abandonment-1ab3d4f/reader/?1608646549823'" />
        </div>
        <div class="row">
            <EmailAbandonedCard
                v-for="(card, index) in abandonedCards"
                :key="index"
                class="col-lg-4"
                :loader="loading"
                :cart-data="card"
            />
        </div>
        <div>
            <EmailBrowseAbandonedTable
                :data="data"
                @freshData="freshData"
            />
            <div class="add-reminder-container">
                <div>
                    <b-btn
                        class="btn blue-btn"
                        @click="createAbandonedCart"
                    >
                        Add Reminder
                    </b-btn>
                </div>
            </div>
        </div>
        <AddEmailCredits
            :show="showModalAddEmailCredits"
            @close="showModalAddEmailCredits = false"
            @submited="showModalAddEmailCredits = false, updBalance()"
        />
    </div>
</template>

<script>
import VideoButton from "@/components/header/VideoButton";
import EmailAbandonedCard from "@/components/email/abandoned-cards/EmailCard";
import EmailBrowseAbandonedTable from "@/components/email/browse-abandonment/EmailBrowseAbandonedTable";
import abandonedCarts from "@/mixins/email/browse-abandonment.service";
import currencies from "@/data/currencies.json";
import shop from '@/mixins/shop.service';
import AddEmailCredits from '@/components/email/AddEmailCredits'
import abTesting from '@/mixins/ab-testing'

export default {
    name: "EmailBrowseAbandonment",
    components: {EmailBrowseAbandonedTable, EmailAbandonedCard, VideoButton, AddEmailCredits,},
    mixins: [abandonedCarts, shop, abTesting],
    data: () => ({
        data: null,
        loading: true,
        shop: null,
        currencies: currencies,
        abandonedCards: [
            {
                title: 'Revenue Recovered',
                icon: 'fa fa-window-maximize',
                salesCount: '0',
                salesTitle: 'Sales'
            },
            {
                title: 'Abandoned browses',
                icon: 'fa fa-users',
                salesCount: '0',
                salesTitle: 'Quantity'
            },
            {
                title: 'Orders Recovered',
                icon: 'fa fa-cube',
                salesCount: '0',
                salesTitle: 'Quantity'
            }
        ],
        showModalAddEmailCredits: false,
        showEmailPlan_B: false,
        balance: null,
    }),
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        },
        isWix() {
            return this.$cookies.get('platform') == 'wix'
        }
    },
    created() {
        this.loadShop()
        this.startABTesting()
        if(this.isWix) this.updBalance()

    },
    mounted() {
        this.freshData()
    },
    methods: {
        async updBalance() {
            this.balance = await this.getBalance()
        },
        async loadShop() {
            this.shop = await this.getShop()
        },
        async freshData() {
            this.data = null
            const response = await this.getBrowseAbandonmentCarts()
            try {
                this.data = response.data
                this.abandonedCards = [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: this.getCurrencySign.symbol_native + this.data.total_revenue,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Abandoned browses',
                        icon: 'fa fa-users',
                        salesCount: this.data.total_carts,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: this.data.total_orders,
                        salesTitle: 'Quantity'
                    }
                ]
                this.loading = false
            } catch (error) {
                console.log(error)
            }
        },
        createAbandonedCart() {
            this.createCart().catch((error) => {
                console.log(error)
            });
        }
    }
}
</script>

<style scoped>


</style>
